'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _clusterize = require('clusterize.js');

var _clusterize2 = _interopRequireDefault(_clusterize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Clusterize = (_temp2 = _class = function (_Component) {
    _inherits(Clusterize, _Component);

    function Clusterize() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Clusterize);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Clusterize.__proto__ || Object.getPrototypeOf(Clusterize)).call.apply(_ref, [this].concat(args))), _this), _this.clusterize = null, _this.scrollElem = null, _this.contentElem = null, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Clusterize, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var scrollElem = _reactDom2.default.findDOMNode(this.scrollElem);
            var contentElem = _reactDom2.default.findDOMNode(this.contentElem);
            var rows = this.props.rows.map(function (row) {
                if (typeof row === 'string') {
                    return row;
                }
                return _react2.default.isValidElement(row) ? _server2.default.renderToString(row) : null;
            });

            this.clusterize = new _clusterize2.default({
                rows: rows,
                scrollElem: scrollElem,
                contentElem: contentElem,
                show_no_data_row: false
            });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.clusterize) {
                this.clusterize.destroy(true);
                this.clusterize = null;
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return false;
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.rows.length === 0) {
                this.clusterize.clear();
                return;
            }
            if (nextProps.rows !== this.props.rows) {
                var rows = nextProps.rows.map(function (row) {
                    if (typeof row === 'string') {
                        return row;
                    }
                    return _react2.default.isValidElement(row) ? _server2.default.renderToString(row) : null;
                });
                this.clusterize && this.clusterize.update(rows);
            }
            if (nextProps.scrollTop !== this.props.scrollTop) {
                this.scrollElem.scrollTop = nextProps.scrollTop;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                className = _props.className,
                style = _props.style;


            return _react2.default.createElement(
                'div',
                {
                    ref: function ref(node) {
                        _this2.scrollElem = node;
                    },
                    className: className,
                    style: _extends({
                        height: '100%',
                        overflow: 'auto'
                    }, style)
                },
                _react2.default.createElement('div', {
                    ref: function ref(node) {
                        _this2.contentElem = node;
                    }
                })
            );
        }
    }]);

    return Clusterize;
}(_react.Component), _class.propTypes = {
    rows: _propTypes2.default.array,
    scrollTop: _propTypes2.default.number
}, _class.defaultProps = {
    rows: [],
    scrollTop: 0
}, _temp2);
exports.default = Clusterize;